# 发行版使用指南

##### 配置运行时环境

Stamon的运行时环境非常简便，您只需要配置至少一个环境变量即可使用：

* ``STAMON``变量：该变量指向可执行文件所在的**目录（而非文件）**
* **[非必要]** ``PATH``变量：在该变量末尾**追加**上可执行文件所在目录

如果不配置PATH变量，则Stamon无法全局使用（即只能在可执行文件所在目录下使用），**因此我们强烈建议您配置PATH变量**

##### 运行指令

Stamon目前支持以下指令：

<br>

* ``stamon version``

该指令用于输出Stamon当前的版本号。

<br>

* ``stamon help``

该指令用于输出Stamon的用法以及各种参数的介绍。

<br>

* ``stamon build [src] [dst] [options...]``

该指令用于编译Stamon代码，其中src为必要参数，表示编译的Stamon文件名，dst为可选参数，表示生成的字节码文件名（默认a.stvc），options为可选参数，他们包括：

|参数用法|功能|默认值|支持此参数的最低版本|
|-|-|-|-|
|--import=&lt;boolean&gt;|是否支持引用源码|true|2.4.4|
|--strip=&lt;boolean&gt;|是否剥削字节码调试信息|false|2.4.4|
|-I&lt;path&gt;|待引用源码所在的路径|无|2.4.4|
|--IgnoreWarning|忽略警告|默认只进行警告|2.4.28|
|--JustWarn|只进行警告|默认只进行警告|2.4.28|
|--FatalWarning|将警告作为致命错误|默认只进行警告|2.4.28|
|--locale=&lt;text&gt;|指定程序运行的语言环境|默认为当前系统的语言环境|2.4.29|


<br>

* ``stamon run [src] [options...]``

该指令用于运行STVC文件，其中src为必要参数，表示编译的Stamon文件名，options为可选参数，他们包括：

|参数用法|功能|默认值|支持此参数的最低版本|
|-|-|-|-|
|--GC=&lt;boolean&gt;|是否运行GC（垃圾自动回收）|true|2.4.4|
|--MemLimit=&lt;Integer&gt;|设置虚拟机的对象内存限制（按字节计）|默认为16,777,216字节，即16MB|2.4.4|
|--MemPoolCache=&lt;Integer&gt;|设置内存池缓存大小（按字节计）|默认为16,777,216字节，即16MB|2.4.19|
|--IgnoreWarning|忽略警告|默认只进行警告|2.4.28|
|--JustWarn|只进行警告|默认只进行警告|2.4.28|
|--FatalWarning|将警告作为致命错误|默认只进行警告|2.4.28|
|--locale=&lt;text&gt;|指定程序运行的语言环境|默认为当前系统的语言环境|2.4.29|

<br>

* ``stamon strip [src]``

该指令用于剥削STVC调试信息，其中src为必要参数，表示待剥削的STVC文件。


> ——摘自``工作日志/20240616.md``，有改动